void __fastcall TDxfXCnvForm::BlockToFrame(TBlock *Block,
  LPDIRECT3DRMFRAME IParent)
{
  TInsert *ins;
  TMeshMaker *Maker;
  string BuilderName, BlockName, FrameName;

  BlockName = *DxfModel->BlockTable.index(*Block);
  TLayIter LayIter(Block->LayTable);
  if (LayIter.home()) do {
     Maker = LayIter.current();
     if (BlockName != "Entities") {
        BuilderName  = BlockName;
        BuilderName += "_";
     } else BuilderName = "";
     BuilderName += *LayIter.currentID();
     if (!Maker->MakeMeshLists(cbDouble->Checked)) continue;
     LPDIRECT3DRMMESHBUILDER Ibuilder = NULL;
     IRM->CreateMeshBuilder(&Ibuilder);
     assert(Ibuilder);
     Ibuilder->AddFaces(Maker->vcount(), Maker->vlist,
                        0, NULL, //    
                        Maker->flist, NULL);
     if (isdigit(BuilderName[0]))
        BuilderName = "_" + BuilderName;
     Ibuilder->SetName(BuilderName.c_str());
     if (cbMaterial->Checked) ColorMesh(Ibuilder, Maker);
     if (!cbMeshFrames->Checked)
        IParent->AddVisual(Ibuilder);
     else {
        LPDIRECT3DRMFRAME Iframe;
        IRM->CreateFrame(IParent, &Iframe);
        Iframe->AddVisual(Ibuilder);
        FrameName = "f" + BuilderName;
        if (CountTable.data(FrameName)) {
          char buf[10];
          int i = CountTable[FrameName]++;
          itoa(i, buf, 10);
          FrameName += "_"; FrameName += buf;
        } else CountTable[FrameName] = 0;
        Iframe->SetName(FrameName.c_str());
        Iframe->Release();
     }
     Ibuilder->Release();
  } while(LayIter.next());

  TInsIter InsIter(Block->InsList);
  if (InsIter.home()) do {
     ins = InsIter.current();
     FrameName = ins->bname;
     TBlock *Block = DxfModel->BlockTable.data(ins->bname);
     LPDIRECT3DRMFRAME Iframe;
     IRM->CreateFrame(IParent, &Iframe);
     if (CountTable.data(FrameName)) {
       char buf[10];
       int i = CountTable[FrameName]++;
       itoa(i, buf, 10);
       FrameName += "_"; FrameName += buf;
     } else CountTable[FrameName] = 0;
     Iframe->SetName(FrameName.c_str());
     Iframe->SetPosition(IParent, ins->x, ins->y, ins->z);
     Iframe->AddScale(D3DRMCOMBINE_BEFORE,
                     ins->scalex, ins->scaley, ins->scalez);
     Iframe->AddRotation(D3DRMCOMBINE_BEFORE,
                              0, 0, 1, ins->angle/180*M_PI);
     BlockToFrame(Block, Iframe);
     Iframe->Release();
  } while(InsIter.next());
}//---------------------------------------------------------